//Copyright (c) 1997 Aidan Cully
//All rights reserved

#ifndef __GRAPHICS_H
#define __GRAPHICS_H

class TGraphicsPrimitives
{
protected:
	unsigned int mXDim, mYDim;
		//X and Y dimensions for the windows
public:
	unsigned int XDim() { return( mXDim ); };
	unsigned int YDim() { return( mYDim ); };
	virtual int GraphicsMode()=0;
	virtual void PutPixel( int, int, unsigned char )=0;
	virtual unsigned char GetPixel( int, int )=0;
	virtual void Line( int, int, int, int, unsigned char );
	virtual void SetScr( unsigned char=0 )=0;
	virtual void Rectangle( int X1, int Y1, int X2, int Y2, unsigned char Color )=0;
	virtual void Bar( int X1, int Y1, int X2, int Y2, unsigned char Color )=0;
	virtual void GetImage( int X1, int Y1, int X2, int Y2, unsigned char *Bmp )=0;
	virtual void PutImage( int X, int Y, unsigned char *Bmp )=0;
	virtual void PutImage( int X, int Y, unsigned char *Bmp, unsigned char Mask )=0;
	void SetColor( unsigned char Index, char Red, char Green, char Blue );
	void GetColor( unsigned char Index, char &Red, char &Green, char &Blue );
	void SetPalette( int NumColors, char *Table );
	char *GetPalette( int NumColors, char *Table );
};

#endif