//Copyright (c) 1997 Aidan Cully
//All rights reserved.

#ifndef __MOUSEHANDLER_H
#define __MOUSEHANDLER_H

#include "CLDeviceHandler.h"

class MMouseListener;

class TMouseHandler:
	public TDeviceHandler
{
private:
	RgnHandle mMouseMoveRgn;
	static TMouseHandler *sCurMouse;
	MMouseListener *mCurListener;
	WindowRef mCurWindow;
protected:
	virtual void BuildEvent( const EventRecord& );
public:
	TMouseHandler();
	virtual ~TMouseHandler();
	virtual void NewDispatcher();
	virtual void OldDispatcher();
	virtual void DispatchEvent( const EventRecord& );
	virtual RgnHandle MouseMoveRgn();
	virtual void CalcMouseMoveRgn();
	static TMouseHandler *SGetMouse() {return( sCurMouse );};
	virtual void SetListener( MMouseListener* );
	virtual MMouseListener *GetListener();
	virtual void GetPosition( Point& );
	virtual Boolean GetButton();
};

#endif