//Copyright (c) 1997 Aidan Cully
//All rights reserved.

#ifndef __MOUSEMOVELISTENER_H
#define __MOUSEMOVELISTENER_H

#include "CLTypes.h"
#include "CLEvent.h"

class TMouseEvent:
	public TEvent
{
public:
	Point where;
};

class TMouseButtonEvent:
	public TMouseEvent
{
public:
	SINT8 button;
};

//This is assumed to be under the mouse.  All mouse clicks are dispatched directly to the
//TMouseHandler's current MMouseListener.  For this reason, it is not a good idea to subclass
//this directly and hook into the mouse unless you REALLY know what you are doing.
class MMouseListener
{
public:
	virtual void HandleMouseMoved( TMouseEvent*, bool )=0;
	virtual void HandleMouse( TMouseButtonEvent* )=0;
};

#endif