//Copyright (c) 1997 Aidan Cully
//All rights reserved

#ifndef __RECTSHAPE_H
#define __RECTSHAPE_H

#include "CLShape.h"
#include "CLStyle.h"
#include "CLTypes.h"

class TRectShape:
	public TShape
{
protected:
	Rect mBounds;
public:
	TRectShape( Rect );
	TRectShape( short, short, short, short );
};

class TFillRectShape:
	public TRectShape
{
protected:
	TStyle *mStyle;
public:
	TFillRectShape( Rect, TStyle* );
	TFillRectShape( short, short, short, short, TStyle* );
	virtual void RenderOn( TDrawSlate* );
};

class TFrameRectShape:
	public TRectShape
{
protected:
	TStyle *mStyle;
public:
	TFrameRectShape( Rect, TStyle* );
	TFrameRectShape( short, short, short, short, TStyle* );
	virtual void RenderOn( TDrawSlate* );
};

class TEraseRectShape:
	public TRectShape
{
public:
	TEraseRectShape( Rect );
	TEraseRectShape( short, short, short, short );
	virtual void RenderOn( TDrawSlate* );
};

#endif