//Copyright (c) 1997 Aidan Cully
//All rights reserved

#include "CLMessenger.h"
#include "CLReceiver.h"

MMessenger::~MMessenger()
{
	mReceivers.MoveLast();
	while( mReceivers.Remove() )
		;
}

Boolean MMessenger::AddReceiver( MReceiver *receiver )
{
	mReceivers.MoveFirst();
	if( !mReceivers.AddPrev( receiver ) )
		return( false );
}

void MMessenger::SendMessage( TMessage *message )
{
	MReceiver *receiver;

	if( !mReceivers.MoveFirst() )
		return;
	do {
		mReceivers.GetData( receiver );
		receiver->ReceiveMessage( message );
	} while( mReceivers.MoveNext() );
}

void MMessenger::SendMessage( UINT32 message )
{
	MReceiver *receiver;
	TMessage *msg= new TMessage( message );

	if( !mReceivers.MoveFirst() )
		return;
	do {
		mReceivers.GetData( receiver );
		receiver->ReceiveMessage( msg );
	} while( mReceivers.MoveNext() );
	delete msg;
}